Package org.postgresql.jdbc

# Class PgResultSet

java.lang.Object
org.postgresql.jdbc.PgResultSet

All Implemented Interfaces:
  `AutoCloseable`, `ResultSet`, `Wrapper`, `PGRefCursorResultSet`

public class PgResultSet extends Object implements ResultSet, PGRefCursorResultSet

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `class`
  `PgResultSet.CursorResultHandler`

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `protected boolean`
  `adaptiveFetch`
  `protected final BaseConnection`
  `connection`
  `protected int`
  `currentRow`
  `protected @Nullable ResultCursor`
  `cursor`
  `protected int`
  `fetchSize`
  `protected final Field[]`
  `fields`
  `protected int`
  `lastUsedFetchSize`
  `protected final int`
  `maxFieldSize`
  `protected final int`
  `maxRows`
  `protected boolean`
  `onInsertRow`
  `protected final @Nullable Query`
  `originalQuery`
  `protected int`
  `rowOffset`
  `protected @Nullable List<Tuple>`
  `rows`
  `protected final BaseStatement`
  `statement`
  `protected @Nullable Tuple`
  `thisRow`
  `protected @Nullable SQLWarning`
  `warnings`
  `protected boolean`
  `wasNullFlag`
  True if the last obtained column value was SQL NULL as specified by `wasNull()`.

  ### Fields inherited from interface java.sql.ResultSet

  `CLOSE_CURSORS_AT_COMMIT, CONCUR_READ_ONLY, CONCUR_UPDATABLE, FETCH_FORWARD, FETCH_REVERSE, FETCH_UNKNOWN, HOLD_CURSORS_OVER_COMMIT, TYPE_FORWARD_ONLY, TYPE_SCROLL_INSENSITIVE, TYPE_SCROLL_SENSITIVE`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `boolean`
  `absolute(int index)`
  `protected void`
  `addWarning(SQLWarning warnings)`
  `void`
  `afterLast()`
  `void`
  `beforeFirst()`
  `void`
  `cancelRowUpdates()`
  `protected void`
  `checkClosed()`
  `protected void`
  `checkColumnIndex(@org.checkerframework.checker.index.qual.Positive int column)`
  `void`
  `clearWarnings()`
  `void`
  `close()`
  `protected void`
  `closeInternally()`
  `static Map<String,Integer>`
  `createColumnNameIndexMap(Field[] fields, boolean isSanitiserDisabled)`
  `protected ResultSetMetaData`
  `createMetaData()`
  `void`
  `deleteRow()`
  `@org.checkerframework.checker.index.qual.NonNegative int`
  `findColumn(String columnName)`
  `boolean`
  `first()`
  `boolean`
  `getAdaptiveFetch()`
  Get state of adaptive fetch for resultSet.
  `@Nullable Array`
  `getArray(int i)`
  `@Nullable Array`
  `getArray(String colName)`
  `@Nullable InputStream`
  `getAsciiStream(@org.checkerframework.checker.index.qual.Positive int columnIndex)`
  `@Nullable InputStream`
  `getAsciiStream(String columnName)`
  `@Nullable BigDecimal`
  `getBigDecimal(@org.checkerframework.checker.index.qual.Positive int columnIndex)`
  `@Nullable BigDecimal`
  `getBigDecimal(int columnIndex, int scale)`
  `@Nullable BigDecimal`
  `getBigDecimal(String columnName)`
  `@Nullable BigDecimal`
  `getBigDecimal(String columnName, int scale)`
  `@Nullable InputStream`
  `getBinaryStream(@org.checkerframework.checker.index.qual.Positive int columnIndex)`
  `@Nullable InputStream`
  `getBinaryStream(String columnName)`
  `@Nullable Blob`
  `getBlob(int i)`
  `@Nullable Blob`
  `getBlob(String columnName)`
  `boolean`
  `getBoolean(@org.checkerframework.checker.index.qual.Positive int columnIndex)`
  Retrieves the value of the designated column in the current row of this `ResultSet` object as a `boolean` in the Java programming language.
  `boolean`
  `getBoolean(String columnName)`
  `byte`
  `getByte(@org.checkerframework.checker.index.qual.Positive int columnIndex)`
  `byte`
  `getByte(String columnName)`
  `byte @Nullable []`
  `getBytes(@org.checkerframework.checker.index.qual.Positive int columnIndex)`
  `byte @Nullable []`
  `getBytes(String columnName)`
  `@Nullable Reader`
  `getCharacterStream(int i)`
  `@Nullable Reader`
  `getCharacterStream(String columnName)`
  `@Nullable Clob`
  `getClob(int i)`
  `@Nullable Clob`
  `getClob(String columnName)`
  `int`
  `getColumnOID(int field)`
  Returns the OID of a field.
  `int`
  `getConcurrency()`
  `@Nullable String`
  `getCursorName()`
  `@Nullable Date`
  `getDate(@org.checkerframework.checker.index.qual.Positive int columnIndex)`
  `@Nullable Date`
  `getDate(int i, @Nullable Calendar cal)`
  `@Nullable Date`
  `getDate(String columnName)`
  `@Nullable Date`
  `getDate(String c, @Nullable Calendar cal)`
  `double`
  `getDouble(@org.checkerframework.checker.index.qual.Positive int columnIndex)`
  `double`
  `getDouble(String columnName)`
  `int`
  `getFetchDirection()`
  `int`
  `getFetchSize()`
  `@Nullable String`
  `getFixedString(int col)`
  This is used to fix get*() methods on Money fields.
  `float`
  `getFloat(@org.checkerframework.checker.index.qual.Positive int columnIndex)`
  `float`
  `getFloat(String columnName)`
  `int`
  `getHoldability()`
  `int`
  `getInt(@org.checkerframework.checker.index.qual.Positive int columnIndex)`
  `int`
  `getInt(String columnName)`
  `int`
  `getLastUsedFetchSize()`
  Get fetch size used during last fetch.
  `long`
  `getLong(@org.checkerframework.checker.index.qual.Positive int columnIndex)`
  `long`
  `getLong(String columnName)`
  `ResultSetMetaData`
  `getMetaData()`
  `@Nullable Reader`
  `getNCharacterStream(@org.checkerframework.checker.index.qual.Positive int columnIndex)`
  `@Nullable Reader`
  `getNCharacterStream(String columnName)`
  `@Nullable NClob`
  `getNClob(@org.checkerframework.checker.index.qual.Positive int columnIndex)`
  `@Nullable NClob`
  `getNClob(String columnName)`
  `@Nullable String`
  `getNString(@org.checkerframework.checker.index.qual.Positive int columnIndex)`
  `@Nullable String`
  `getNString(String columnName)`
  `@Nullable Object`
  `getObject(@org.checkerframework.checker.index.qual.Positive int columnIndex)`
  `<T> @Nullable T`
  `getObject(@org.checkerframework.checker.index.qual.Positive int columnIndex, Class<T> type)`
  `@Nullable Object`
  `getObject(@org.checkerframework.checker.index.qual.Positive int i, @Nullable Map<String,Class<?>> map)`
  `@Nullable Object`
  `getObject(String columnName)`
  `<T> @Nullable T`
  `getObject(String columnLabel, Class<T> type)`
  `@Nullable Object`
  `getObject(String s, @Nullable Map<String,Class<?>> map)`
  `@Nullable Object`
  `getObjectImpl(int i, @Nullable Map<String,Class<?>> map)`
  `@Nullable Object`
  `getObjectImpl(String columnName, @Nullable Map<String,Class<?>> map)`
  `BaseStatement`
  `getPGStatement()`
  `protected String`
  `getPGType(@org.checkerframework.checker.index.qual.Positive int column)`
  `protected byte @Nullable []`
  `getRawValue(@org.checkerframework.checker.index.qual.Positive int column)`
  Checks that the result set is not closed, it's positioned on a valid row and that the given column number is valid.
  `@Nullable Ref`
  `getRef(int i)`
  `@Nullable Ref`
  `getRef(String columnName)`
  `@Nullable String`
  `getRefCursor()`
  `int`
  `getRow()`
  `@Nullable RowId`
  `getRowId(@org.checkerframework.checker.index.qual.Positive int columnIndex)`
  `@Nullable RowId`
  `getRowId(String columnName)`
  `short`
  `getShort(@org.checkerframework.checker.index.qual.Positive int columnIndex)`
  `short`
  `getShort(String columnName)`
  `protected int`
  `getSQLType(@org.checkerframework.checker.index.qual.Positive int column)`
  `@Nullable SQLXML`
  `getSQLXML(@org.checkerframework.checker.index.qual.Positive int columnIndex)`
  `@Nullable SQLXML`
  `getSQLXML(String columnName)`
  `Statement`
  `getStatement()`
  `@Nullable String`
  `getString(@org.checkerframework.checker.index.qual.Positive int columnIndex)`
  `@Nullable String`
  `getString(String columnName)`
  `@Nullable Time`
  `getTime(@org.checkerframework.checker.index.qual.Positive int columnIndex)`
  `@Nullable Time`
  `getTime(int i, @Nullable Calendar cal)`
  `@Nullable Time`
  `getTime(String columnName)`
  `@Nullable Time`
  `getTime(String c, @Nullable Calendar cal)`
  `@Nullable Timestamp`
  `getTimestamp(@org.checkerframework.checker.index.qual.Positive int columnIndex)`
  `@Nullable Timestamp`
  `getTimestamp(int i, @Nullable Calendar cal)`
  `@Nullable Timestamp`
  `getTimestamp(String columnName)`
  `@Nullable Timestamp`
  `getTimestamp(String c, @Nullable Calendar cal)`
  `int`
  `getType()`
  `@Nullable InputStream`
  `getUnicodeStream(@org.checkerframework.checker.index.qual.Positive int columnIndex)`
  `@Nullable InputStream`
  `getUnicodeStream(String columnName)`
  `URL`
  `getURL(@org.checkerframework.checker.index.qual.Positive int columnIndex)`
  `URL`
  `getURL(String columnName)`
  `protected Object`
  `getUUID(byte[] data)`
  `protected Object`
  `getUUID(String data)`
  `@Nullable SQLWarning`
  `getWarnings()`
  `void`
  `insertRow()`
  `protected @Nullable Object`
  `internalGetObject(@org.checkerframework.checker.index.qual.Positive int columnIndex, Field field)`
  `boolean`
  `isAfterLast()`
  `boolean`
  `isBeforeFirst()`
  `protected boolean`
  `isBinary(@org.checkerframework.checker.index.qual.Positive int column)`
  Returns true if the value of the given column is in binary format.
  `boolean`
  `isClosed()`
  `boolean`
  `isFirst()`
  `boolean`
  `isLast()`
  `protected boolean`
  `isResultSetClosed()`
  `boolean`
  `isWrapperFor(Class<?> iface)`
  `boolean`
  `last()`
  `protected Array`
  `makeArray(int oid, byte[] value)`
  `protected Array`
  `makeArray(int oid, String value)`
  `protected Blob`
  `makeBlob(long oid)`
  `protected Clob`
  `makeClob(long oid)`
  `void`
  `moveToCurrentRow()`
  `void`
  `moveToInsertRow()`
  `boolean`
  `next()`
  `boolean`
  `previous()`
  `static @Nullable String[]`
  `quotelessTableName(String fullname)`
  Cracks out the table name and schema (if it exists) from a fully qualified table name.
  `void`
  `refreshRow()`
  `boolean`
  `relative(int rows)`
  `boolean`
  `rowDeleted()`
  `boolean`
  `rowInserted()`
  `boolean`
  `rowUpdated()`
  `void`
  `setAdaptiveFetch(boolean adaptiveFetch)`
  Turn on/off adaptive fetch for ResultSet.
  `void`
  `setFetchDirection(int direction)`
  `void`
  `setFetchSize(int rows)`
  `static @PolyNull BigDecimal`
  `toBigDecimal(@PolyNull String s)`
  `static @PolyNull BigDecimal`
  `toBigDecimal(@PolyNull String s, int scale)`
  `static double`
  `toDouble(@Nullable String s)`
  `static float`
  `toFloat(@Nullable String s)`
  `static int`
  `toInt(@Nullable String s)`
  `static long`
  `toLong(@Nullable String s)`
  `static short`
  `toShort(@Nullable String s)`
  `<T> T`
  `unwrap(Class<T> iface)`
  `void`
  `updateArray(@org.checkerframework.checker.index.qual.Positive int columnIndex, @Nullable Array x)`
  `void`
  `updateArray(String columnName, @Nullable Array x)`
  `void`
  `updateAsciiStream(@org.checkerframework.checker.index.qual.Positive int columnIndex, @Nullable InputStream inputStream)`
  `void`
  `updateAsciiStream(@org.checkerframework.checker.index.qual.Positive int columnIndex, @Nullable InputStream x, int length)`
  `void`
  `updateAsciiStream(@org.checkerframework.checker.index.qual.Positive int columnIndex, @Nullable InputStream inputStream, long length)`
  `void`
  `updateAsciiStream(String columnName, @Nullable InputStream inputStream)`
  `void`
  `updateAsciiStream(String columnName, @Nullable InputStream x, int length)`
  `void`
  `updateAsciiStream(String columnName, @Nullable InputStream inputStream, long length)`
  `void`
  `updateBigDecimal(@org.checkerframework.checker.index.qual.Positive int columnIndex, @Nullable BigDecimal x)`
  `void`
  `updateBigDecimal(String columnName, @Nullable BigDecimal x)`
  `void`
  `updateBinaryStream(@org.checkerframework.checker.index.qual.Positive int columnIndex, @Nullable InputStream inputStream)`
  `void`
  `updateBinaryStream(@org.checkerframework.checker.index.qual.Positive int columnIndex, @Nullable InputStream x, int length)`
  `void`
  `updateBinaryStream(@org.checkerframework.checker.index.qual.Positive int columnIndex, @Nullable InputStream inputStream, long length)`
  `void`
  `updateBinaryStream(String columnName, @Nullable InputStream inputStream)`
  `void`
  `updateBinaryStream(String columnName, @Nullable InputStream x, int length)`
  `void`
  `updateBinaryStream(String columnName, @Nullable InputStream inputStream, long length)`
  `void`
  `updateBlob(@org.checkerframework.checker.index.qual.Positive int columnIndex, @Nullable InputStream inputStream)`
  `void`
  `updateBlob(@org.checkerframework.checker.index.qual.Positive int columnIndex, @Nullable InputStream inputStream, long length)`
  `void`
  `updateBlob(@org.checkerframework.checker.index.qual.Positive int columnIndex, @Nullable Blob x)`
  `void`
  `updateBlob(String columnName, @Nullable InputStream inputStream)`
  `void`
  `updateBlob(String columnName, @Nullable InputStream inputStream, long length)`
  `void`
  `updateBlob(String columnName, @Nullable Blob x)`
  `void`
  `updateBoolean(@org.checkerframework.checker.index.qual.Positive int columnIndex, boolean x)`
  `void`
  `updateBoolean(String columnName, boolean x)`
  `void`
  `updateByte(@org.checkerframework.checker.index.qual.Positive int columnIndex, byte x)`
  `void`
  `updateByte(String columnName, byte x)`
  `void`
  `updateBytes(@org.checkerframework.checker.index.qual.Positive int columnIndex, byte @Nullable [] x)`
  `void`
  `updateBytes(String columnName, byte @Nullable [] x)`
  `void`
  `updateCharacterStream(@org.checkerframework.checker.index.qual.Positive int columnIndex, @Nullable Reader reader)`
  `void`
  `updateCharacterStream(@org.checkerframework.checker.index.qual.Positive int columnIndex, @Nullable Reader x, int length)`
  `void`
  `updateCharacterStream(@org.checkerframework.checker.index.qual.Positive int columnIndex, @Nullable Reader reader, long length)`
  `void`
  `updateCharacterStream(String columnName, @Nullable Reader reader)`
  `void`
  `updateCharacterStream(String columnName, @Nullable Reader reader, int length)`
  `void`
  `updateCharacterStream(String columnName, @Nullable Reader reader, long length)`
  `void`
  `updateClob(@org.checkerframework.checker.index.qual.Positive int columnIndex, @Nullable Reader reader)`
  `void`
  `updateClob(@org.checkerframework.checker.index.qual.Positive int columnIndex, @Nullable Reader reader, long length)`
  `void`
  `updateClob(@org.checkerframework.checker.index.qual.Positive int columnIndex, @Nullable Clob x)`
  `void`
  `updateClob(String columnName, @Nullable Reader reader)`
  `void`
  `updateClob(String columnName, @Nullable Reader reader, long length)`
  `void`
  `updateClob(String columnName, @Nullable Clob x)`
  `void`
  `updateDate(@org.checkerframework.checker.index.qual.Positive int columnIndex, @Nullable Date x)`
  `void`
  `updateDate(String columnName, @Nullable Date x)`
  `void`
  `updateDouble(@org.checkerframework.checker.index.qual.Positive int columnIndex, double x)`
  `void`
  `updateDouble(String columnName, double x)`
  `void`
  `updateFloat(@org.checkerframework.checker.index.qual.Positive int columnIndex, float x)`
  `void`
  `updateFloat(String columnName, float x)`
  `void`
  `updateInt(@org.checkerframework.checker.index.qual.Positive int columnIndex, int x)`
  `void`
  `updateInt(String columnName, int x)`
  `void`
  `updateLong(@org.checkerframework.checker.index.qual.Positive int columnIndex, long x)`
  `void`
  `updateLong(String columnName, long x)`
  `void`
  `updateNCharacterStream(@org.checkerframework.checker.index.qual.Positive int columnIndex, @Nullable Reader x)`
  `void`
  `updateNCharacterStream(@org.checkerframework.checker.index.qual.Positive int columnIndex, @Nullable Reader x, int length)`
  `void`
  `updateNCharacterStream(@org.checkerframework.checker.index.qual.Positive int columnIndex, @Nullable Reader x, long length)`
  `void`
  `updateNCharacterStream(String columnName, @Nullable Reader x)`
  `void`
  `updateNCharacterStream(String columnName, @Nullable Reader x, int length)`
  `void`
  `updateNCharacterStream(String columnName, @Nullable Reader x, long length)`
  `void`
  `updateNClob(@org.checkerframework.checker.index.qual.Positive int columnIndex, @Nullable Reader reader)`
  `void`
  `updateNClob(@org.checkerframework.checker.index.qual.Positive int columnIndex, @Nullable Reader reader, long length)`
  `void`
  `updateNClob(@org.checkerframework.checker.index.qual.Positive int columnIndex, @Nullable NClob nClob)`
  `void`
  `updateNClob(String columnName, @Nullable Reader reader)`
  `void`
  `updateNClob(String columnName, @Nullable Reader reader, long length)`
  `void`
  `updateNClob(String columnName, @Nullable NClob nClob)`
  `void`
  `updateNString(@org.checkerframework.checker.index.qual.Positive int columnIndex, @Nullable String nString)`
  `void`
  `updateNString(String columnName, @Nullable String nString)`
  `void`
  `updateNull(@org.checkerframework.checker.index.qual.Positive int columnIndex)`
  `void`
  `updateNull(String columnName)`
  `void`
  `updateObject(@org.checkerframework.checker.index.qual.Positive int columnIndex, @Nullable Object x, SQLType targetSqlType)`
  `void`
  `updateObject(@org.checkerframework.checker.index.qual.Positive int columnIndex, @Nullable Object x, SQLType targetSqlType, int scaleOrLength)`
  `void`
  `updateObject(int columnIndex, @Nullable Object x)`
  `void`
  `updateObject(int columnIndex, @Nullable Object x, int scale)`
  `void`
  `updateObject(String columnName, @Nullable Object x)`
  `void`
  `updateObject(String columnName, @Nullable Object x, int scale)`
  `void`
  `updateObject(String columnLabel, @Nullable Object x, SQLType targetSqlType)`
  `void`
  `updateObject(String columnLabel, @Nullable Object x, SQLType targetSqlType, int scaleOrLength)`
  `void`
  `updateRef(@org.checkerframework.checker.index.qual.Positive int columnIndex, @Nullable Ref x)`
  `void`
  `updateRef(String columnName, @Nullable Ref x)`
  `void`
  `updateRow()`
  `void`
  `updateRowId(@org.checkerframework.checker.index.qual.Positive int columnIndex, @Nullable RowId x)`
  `void`
  `updateRowId(String columnName, @Nullable RowId x)`
  `void`
  `updateShort(@org.checkerframework.checker.index.qual.Positive int columnIndex, short x)`
  `void`
  `updateShort(String columnName, short x)`
  `void`
  `updateSQLXML(@org.checkerframework.checker.index.qual.Positive int columnIndex, @Nullable SQLXML xmlObject)`
  `void`
  `updateSQLXML(String columnName, @Nullable SQLXML xmlObject)`
  `void`
  `updateString(@org.checkerframework.checker.index.qual.Positive int columnIndex, @Nullable String x)`
  `void`
  `updateString(String columnName, @Nullable String x)`
  `void`
  `updateTime(@org.checkerframework.checker.index.qual.Positive int columnIndex, @Nullable Time x)`
  `void`
  `updateTime(String columnName, @Nullable Time x)`
  `void`
  `updateTimestamp(int columnIndex, @Nullable Timestamp x)`
  `void`
  `updateTimestamp(String columnName, @Nullable Timestamp x)`
  `protected void`
  `updateValue(@org.checkerframework.checker.index.qual.Positive int columnIndex, @Nullable Object value)`
  `protected PgResultSet`
  `upperCaseFieldLabels()`
  This is here to be used by metadata functions to make all column labels upper case.
  `boolean`
  `wasNull()`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### connection

    protected final BaseConnection connection

  - ### statement

    protected final BaseStatement statement

  - ### fields

    protected final Field[] fields

  - ### originalQuery

    protected final @Nullable Query originalQuery

  - ### maxRows

    protected final int maxRows

  - ### maxFieldSize

    protected final int maxFieldSize

  - ### rows

    protected @Nullable List<Tuple> rows

  - ### currentRow

    protected int currentRow

  - ### rowOffset

    protected int rowOffset

  - ### thisRow

    protected @Nullable Tuple thisRow

  - ### warnings

    protected @Nullable SQLWarning warnings

  - ### wasNullFlag

    protected boolean wasNullFlag
    True if the last obtained column value was SQL NULL as specified by `wasNull()`. The value is always updated by the `getRawValue(int)` method.

  - ### onInsertRow

    protected boolean onInsertRow

  - ### fetchSize

    protected int fetchSize

  - ### lastUsedFetchSize

    protected int lastUsedFetchSize

  - ### adaptiveFetch

    protected boolean adaptiveFetch

  - ### cursor

    protected @Nullable ResultCursor cursor

- ## Method Details

  - ### createMetaData

    protected ResultSetMetaData createMetaData() throws SQLException
    Throws:
      `SQLException`

  - ### getMetaData

    public ResultSetMetaData getMetaData() throws SQLException
    Specified by:
      `getMetaData` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### getURL

    public URL getURL(@org.checkerframework.checker.index.qual.Positive int columnIndex) throws SQLException
    Specified by:
      `getURL` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### getURL

    public URL getURL(String columnName) throws SQLException
    Specified by:
      `getURL` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### internalGetObject

    @RequiresNonNull("thisRow") protected @Nullable Object internalGetObject(@org.checkerframework.checker.index.qual.Positive int columnIndex, Field field) throws SQLException
    Throws:
      `SQLException`

  - ### absolute

    public boolean absolute(int index) throws SQLException
    Specified by:
      `absolute` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### afterLast

    public void afterLast() throws SQLException
    Specified by:
      `afterLast` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### beforeFirst

    public void beforeFirst() throws SQLException
    Specified by:
      `beforeFirst` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### first

    public boolean first() throws SQLException
    Specified by:
      `first` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### getArray

    public @Nullable Array getArray(String colName) throws SQLException
    Specified by:
      `getArray` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### makeArray

    protected Array makeArray(int oid, byte[] value) throws SQLException
    Throws:
      `SQLException`

  - ### makeArray

    protected Array makeArray(int oid, String value) throws SQLException
    Throws:
      `SQLException`

  - ### getArray

    @Pure public @Nullable Array getArray(int i) throws SQLException
    Specified by:
      `getArray` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### getBigDecimal

    public @Nullable BigDecimal getBigDecimal(@org.checkerframework.checker.index.qual.Positive int columnIndex) throws SQLException
    Specified by:
      `getBigDecimal` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### getBigDecimal

    public @Nullable BigDecimal getBigDecimal(String columnName) throws SQLException
    Specified by:
      `getBigDecimal` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### getBlob

    public @Nullable Blob getBlob(String columnName) throws SQLException
    Specified by:
      `getBlob` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### makeBlob

    protected Blob makeBlob(long oid) throws SQLException
    Throws:
      `SQLException`

  - ### getBlob

    @Pure public @Nullable Blob getBlob(int i) throws SQLException
    Specified by:
      `getBlob` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### getCharacterStream

    public @Nullable Reader getCharacterStream(String columnName) throws SQLException
    Specified by:
      `getCharacterStream` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### getCharacterStream

    public @Nullable Reader getCharacterStream(int i) throws SQLException
    Specified by:
      `getCharacterStream` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### getClob

    public @Nullable Clob getClob(String columnName) throws SQLException
    Specified by:
      `getClob` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### makeClob

    protected Clob makeClob(long oid) throws SQLException
    Throws:
      `SQLException`

  - ### getClob

    @Pure public @Nullable Clob getClob(int i) throws SQLException
    Specified by:
      `getClob` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### getConcurrency

    public int getConcurrency() throws SQLException
    Specified by:
      `getConcurrency` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### getDate

    public @Nullable Date getDate(int i, @Nullable Calendar cal) throws SQLException
    Specified by:
      `getDate` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### getTime

    public @Nullable Time getTime(int i, @Nullable Calendar cal) throws SQLException
    Specified by:
      `getTime` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### getTimestamp

    @Pure public @Nullable Timestamp getTimestamp(int i, @Nullable Calendar cal) throws SQLException
    Specified by:
      `getTimestamp` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### getDate

    public @Nullable Date getDate(String c, @Nullable Calendar cal) throws SQLException
    Specified by:
      `getDate` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### getTime

    public @Nullable Time getTime(String c, @Nullable Calendar cal) throws SQLException
    Specified by:
      `getTime` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### getTimestamp

    public @Nullable Timestamp getTimestamp(String c, @Nullable Calendar cal) throws SQLException
    Specified by:
      `getTimestamp` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### getFetchDirection

    public int getFetchDirection() throws SQLException
    Specified by:
      `getFetchDirection` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### getObjectImpl

    public @Nullable Object getObjectImpl(String columnName, @Nullable Map<String,Class<?>> map) throws SQLException
    Throws:
      `SQLException`

  - ### getObjectImpl

    public @Nullable Object getObjectImpl(int i, @Nullable Map<String,Class<?>> map) throws SQLException
    Throws:
      `SQLException`

  - ### getRef

    public @Nullable Ref getRef(String columnName) throws SQLException
    Specified by:
      `getRef` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### getRef

    public @Nullable Ref getRef(int i) throws SQLException
    Specified by:
      `getRef` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### getRow

    public int getRow() throws SQLException
    Specified by:
      `getRow` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### getStatement

    public Statement getStatement() throws SQLException
    Specified by:
      `getStatement` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### getType

    public int getType() throws SQLException
    Specified by:
      `getType` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### isAfterLast

    @Pure public boolean isAfterLast() throws SQLException
    Specified by:
      `isAfterLast` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### isBeforeFirst

    @Pure public boolean isBeforeFirst() throws SQLException
    Specified by:
      `isBeforeFirst` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### isFirst

    public boolean isFirst() throws SQLException
    Specified by:
      `isFirst` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### isLast

    public boolean isLast() throws SQLException
    Specified by:
      `isLast` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### last

    public boolean last() throws SQLException
    Specified by:
      `last` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### previous

    public boolean previous() throws SQLException
    Specified by:
      `previous` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### relative

    public boolean relative(int rows) throws SQLException
    Specified by:
      `relative` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### setFetchDirection

    public void setFetchDirection(int direction) throws SQLException
    Specified by:
      `setFetchDirection` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### cancelRowUpdates

    public void cancelRowUpdates() throws SQLException
    Specified by:
      `cancelRowUpdates` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### deleteRow

    public void deleteRow() throws SQLException
    Specified by:
      `deleteRow` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### insertRow

    public void insertRow() throws SQLException
    Specified by:
      `insertRow` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### moveToCurrentRow

    public void moveToCurrentRow() throws SQLException
    Specified by:
      `moveToCurrentRow` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### moveToInsertRow

    public void moveToInsertRow() throws SQLException
    Specified by:
      `moveToInsertRow` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### rowDeleted

    public boolean rowDeleted() throws SQLException
    Specified by:
      `rowDeleted` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### rowInserted

    public boolean rowInserted() throws SQLException
    Specified by:
      `rowInserted` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### rowUpdated

    public boolean rowUpdated() throws SQLException
    Specified by:
      `rowUpdated` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateAsciiStream

    public void updateAsciiStream(@org.checkerframework.checker.index.qual.Positive int columnIndex, @Nullable InputStream x, int length) throws SQLException
    Specified by:
      `updateAsciiStream` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateBigDecimal

    public void updateBigDecimal(@org.checkerframework.checker.index.qual.Positive int columnIndex, @Nullable BigDecimal x) throws SQLException
    Specified by:
      `updateBigDecimal` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateBinaryStream

    public void updateBinaryStream(@org.checkerframework.checker.index.qual.Positive int columnIndex, @Nullable InputStream x, int length) throws SQLException
    Specified by:
      `updateBinaryStream` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateBoolean

    public void updateBoolean(@org.checkerframework.checker.index.qual.Positive int columnIndex, boolean x) throws SQLException
    Specified by:
      `updateBoolean` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateByte

    public void updateByte(@org.checkerframework.checker.index.qual.Positive int columnIndex, byte x) throws SQLException
    Specified by:
      `updateByte` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateBytes

    public void updateBytes(@org.checkerframework.checker.index.qual.Positive int columnIndex, byte @Nullable [] x) throws SQLException
    Specified by:
      `updateBytes` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateCharacterStream

    public void updateCharacterStream(@org.checkerframework.checker.index.qual.Positive int columnIndex, @Nullable Reader x, int length) throws SQLException
    Specified by:
      `updateCharacterStream` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateDate

    public void updateDate(@org.checkerframework.checker.index.qual.Positive int columnIndex, @Nullable Date x) throws SQLException
    Specified by:
      `updateDate` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateDouble

    public void updateDouble(@org.checkerframework.checker.index.qual.Positive int columnIndex, double x) throws SQLException
    Specified by:
      `updateDouble` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateFloat

    public void updateFloat(@org.checkerframework.checker.index.qual.Positive int columnIndex, float x) throws SQLException
    Specified by:
      `updateFloat` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateInt

    public void updateInt(@org.checkerframework.checker.index.qual.Positive int columnIndex, int x) throws SQLException
    Specified by:
      `updateInt` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateLong

    public void updateLong(@org.checkerframework.checker.index.qual.Positive int columnIndex, long x) throws SQLException
    Specified by:
      `updateLong` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateNull

    public void updateNull(@org.checkerframework.checker.index.qual.Positive int columnIndex) throws SQLException
    Specified by:
      `updateNull` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateObject

    public void updateObject(int columnIndex, @Nullable Object x) throws SQLException
    Specified by:
      `updateObject` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateObject

    public void updateObject(int columnIndex, @Nullable Object x, int scale) throws SQLException
    Specified by:
      `updateObject` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### refreshRow

    public void refreshRow() throws SQLException
    Specified by:
      `refreshRow` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateRow

    public void updateRow() throws SQLException
    Specified by:
      `updateRow` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateShort

    public void updateShort(@org.checkerframework.checker.index.qual.Positive int columnIndex, short x) throws SQLException
    Specified by:
      `updateShort` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateString

    public void updateString(@org.checkerframework.checker.index.qual.Positive int columnIndex, @Nullable String x) throws SQLException
    Specified by:
      `updateString` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateTime

    public void updateTime(@org.checkerframework.checker.index.qual.Positive int columnIndex, @Nullable Time x) throws SQLException
    Specified by:
      `updateTime` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateTimestamp

    public void updateTimestamp(int columnIndex, @Nullable Timestamp x) throws SQLException
    Specified by:
      `updateTimestamp` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateNull

    public void updateNull(String columnName) throws SQLException
    Specified by:
      `updateNull` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateBoolean

    public void updateBoolean(String columnName, boolean x) throws SQLException
    Specified by:
      `updateBoolean` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateByte

    public void updateByte(String columnName, byte x) throws SQLException
    Specified by:
      `updateByte` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateShort

    public void updateShort(String columnName, short x) throws SQLException
    Specified by:
      `updateShort` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateInt

    public void updateInt(String columnName, int x) throws SQLException
    Specified by:
      `updateInt` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateLong

    public void updateLong(String columnName, long x) throws SQLException
    Specified by:
      `updateLong` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateFloat

    public void updateFloat(String columnName, float x) throws SQLException
    Specified by:
      `updateFloat` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateDouble

    public void updateDouble(String columnName, double x) throws SQLException
    Specified by:
      `updateDouble` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateBigDecimal

    public void updateBigDecimal(String columnName, @Nullable BigDecimal x) throws SQLException
    Specified by:
      `updateBigDecimal` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateString

    public void updateString(String columnName, @Nullable String x) throws SQLException
    Specified by:
      `updateString` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateBytes

    public void updateBytes(String columnName, byte @Nullable [] x) throws SQLException
    Specified by:
      `updateBytes` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateDate

    public void updateDate(String columnName, @Nullable Date x) throws SQLException
    Specified by:
      `updateDate` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateTime

    public void updateTime(String columnName, @Nullable Time x) throws SQLException
    Specified by:
      `updateTime` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateTimestamp

    public void updateTimestamp(String columnName, @Nullable Timestamp x) throws SQLException
    Specified by:
      `updateTimestamp` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateAsciiStream

    public void updateAsciiStream(String columnName, @Nullable InputStream x, int length) throws SQLException
    Specified by:
      `updateAsciiStream` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateBinaryStream

    public void updateBinaryStream(String columnName, @Nullable InputStream x, int length) throws SQLException
    Specified by:
      `updateBinaryStream` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateCharacterStream

    public void updateCharacterStream(String columnName, @Nullable Reader reader, int length) throws SQLException
    Specified by:
      `updateCharacterStream` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateObject

    public void updateObject(String columnName, @Nullable Object x, int scale) throws SQLException
    Specified by:
      `updateObject` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateObject

    public void updateObject(String columnName, @Nullable Object x) throws SQLException
    Specified by:
      `updateObject` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### setAdaptiveFetch

    public void setAdaptiveFetch(boolean adaptiveFetch) throws SQLException
    Turn on/off adaptive fetch for ResultSet.
    Parameters:
      `adaptiveFetch` - desired state of adaptive fetch.
    Throws:
      `SQLException` - exception returned if ResultSet is closed

  - ### getAdaptiveFetch

    public boolean getAdaptiveFetch() throws SQLException
    Get state of adaptive fetch for resultSet.
    Returns:
      state of adaptive fetch (turned on or off)
    Throws:
      `SQLException` - exception returned if ResultSet is closed

  - ### quotelessTableName

    public static @Nullable String[] quotelessTableName(String fullname)
    Cracks out the table name and schema (if it exists) from a fully qualified table name.
    Parameters:
      `fullname` - string that we are trying to crack. Test cases:

                           Table: table
                                           ()

                           "Table": Table
                                           ()

                           Schema.Table:
                                           table (schema)

                                           "Schema"."Table": Table
                                                           (Schema)

                                           "Schema"."Dot.Table": Dot.Table
                                                           (Schema)

                                           Schema."Dot.Table": Dot.Table
                                                           (schema)

    Returns:
      String array with element zero always being the tablename and element 1 the schema name which may be a zero length string.

  - ### getPGStatement

    public BaseStatement getPGStatement()

  - ### getRefCursor

    public @Nullable String getRefCursor()
    Specified by:
      `getRefCursor` in interface `PGRefCursorResultSet`
    Returns:
      the name of the cursor.

  - ### setFetchSize

    public void setFetchSize(int rows) throws SQLException
    Specified by:
      `setFetchSize` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### getFetchSize

    public int getFetchSize() throws SQLException
    Specified by:
      `getFetchSize` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### getLastUsedFetchSize

    public int getLastUsedFetchSize() throws SQLException
    Get fetch size used during last fetch. Returned value can be useful if using adaptive fetch.
    Returns:
      fetch size used during last fetch.
    Throws:
      `SQLException` - exception returned if ResultSet is closed

  - ### next

    public boolean next() throws SQLException
    Specified by:
      `next` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### close

    public void close() throws SQLException
    Specified by:
      `close` in interface `AutoCloseable`
    Specified by:
      `close` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### closeInternally

    protected void closeInternally() throws SQLException
    Throws:
      `SQLException`

  - ### wasNull

    public boolean wasNull() throws SQLException
    Specified by:
      `wasNull` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### getString

    @Pure public @Nullable String getString(@org.checkerframework.checker.index.qual.Positive int columnIndex) throws SQLException
    Specified by:
      `getString` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### getBoolean

    @Pure public boolean getBoolean(@org.checkerframework.checker.index.qual.Positive int columnIndex) throws SQLException
    Retrieves the value of the designated column in the current row of this `ResultSet` object as a `boolean` in the Java programming language.

    If the designated column has a Character datatype and is one of the following values: "1", "true", "t", "yes", "y" or "on", a value of `true` is returned. If the designated column has a Character datatype and is one of the following values: "0", "false", "f", "no", "n" or "off", a value of `false` is returned. Leading or trailing whitespace is ignored, and case does not matter.

    If the designated column has a Numeric datatype and is a 1, a value of `true` is returned. If the designated column has a Numeric datatype and is a 0, a value of `false` is returned.

    Specified by:
      `getBoolean` in interface `ResultSet`
    Parameters:
      `columnIndex` - the first column is 1, the second is 2, ...
    Returns:
      the column value; if the value is SQL `NULL`, the value returned is `false`
    Throws:
      `SQLException` - if the columnIndex is not valid; if a database access error occurs; if this method is called on a closed result set or is an invalid cast to boolean type.
    See Also:
      - PostgreSQL Boolean Type

  - ### getByte

    public byte getByte(@org.checkerframework.checker.index.qual.Positive int columnIndex) throws SQLException
    Specified by:
      `getByte` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### getShort

    public short getShort(@org.checkerframework.checker.index.qual.Positive int columnIndex) throws SQLException
    Specified by:
      `getShort` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### getInt

    @Pure public int getInt(@org.checkerframework.checker.index.qual.Positive int columnIndex) throws SQLException
    Specified by:
      `getInt` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### getLong

    @Pure public long getLong(@org.checkerframework.checker.index.qual.Positive int columnIndex) throws SQLException
    Specified by:
      `getLong` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### getFloat

    @Pure public float getFloat(@org.checkerframework.checker.index.qual.Positive int columnIndex) throws SQLException
    Specified by:
      `getFloat` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### getDouble

    @Pure public double getDouble(@org.checkerframework.checker.index.qual.Positive int columnIndex) throws SQLException
    Specified by:
      `getDouble` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### getBigDecimal

    public @Nullable BigDecimal getBigDecimal(int columnIndex, int scale) throws SQLException
    Specified by:
      `getBigDecimal` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### getBytes

    @Pure public byte @Nullable [] getBytes(@org.checkerframework.checker.index.qual.Positive int columnIndex) throws SQLException

    In normal use, the bytes represent the raw values returned by the backend. However, if the column is an OID, then it is assumed to refer to a Large Object, and that object is returned as a byte array.

    Be warned If the large object is huge, then you may run out of memory.

    Specified by:
      `getBytes` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### getDate

    @Pure public @Nullable Date getDate(@org.checkerframework.checker.index.qual.Positive int columnIndex) throws SQLException
    Specified by:
      `getDate` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### getTime

    @Pure public @Nullable Time getTime(@org.checkerframework.checker.index.qual.Positive int columnIndex) throws SQLException
    Specified by:
      `getTime` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### getTimestamp

    @Pure public @Nullable Timestamp getTimestamp(@org.checkerframework.checker.index.qual.Positive int columnIndex) throws SQLException
    Specified by:
      `getTimestamp` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### getAsciiStream

    @Pure public @Nullable InputStream getAsciiStream(@org.checkerframework.checker.index.qual.Positive int columnIndex) throws SQLException
    Specified by:
      `getAsciiStream` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### getUnicodeStream

    @Pure public @Nullable InputStream getUnicodeStream(@org.checkerframework.checker.index.qual.Positive int columnIndex) throws SQLException
    Specified by:
      `getUnicodeStream` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### getBinaryStream

    @Pure public @Nullable InputStream getBinaryStream(@org.checkerframework.checker.index.qual.Positive int columnIndex) throws SQLException
    Specified by:
      `getBinaryStream` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### getString

    @Pure public @Nullable String getString(String columnName) throws SQLException
    Specified by:
      `getString` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### getBoolean

    @Pure public boolean getBoolean(String columnName) throws SQLException
    Specified by:
      `getBoolean` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### getByte

    @Pure public byte getByte(String columnName) throws SQLException
    Specified by:
      `getByte` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### getShort

    @Pure public short getShort(String columnName) throws SQLException
    Specified by:
      `getShort` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### getInt

    @Pure public int getInt(String columnName) throws SQLException
    Specified by:
      `getInt` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### getLong

    @Pure public long getLong(String columnName) throws SQLException
    Specified by:
      `getLong` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### getFloat

    @Pure public float getFloat(String columnName) throws SQLException
    Specified by:
      `getFloat` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### getDouble

    @Pure public double getDouble(String columnName) throws SQLException
    Specified by:
      `getDouble` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### getBigDecimal

    @Pure public @Nullable BigDecimal getBigDecimal(String columnName, int scale) throws SQLException
    Specified by:
      `getBigDecimal` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### getBytes

    @Pure public byte @Nullable [] getBytes(String columnName) throws SQLException
    Specified by:
      `getBytes` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### getDate

    @Pure public @Nullable Date getDate(String columnName) throws SQLException
    Specified by:
      `getDate` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### getTime

    @Pure public @Nullable Time getTime(String columnName) throws SQLException
    Specified by:
      `getTime` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### getTimestamp

    @Pure public @Nullable Timestamp getTimestamp(String columnName) throws SQLException
    Specified by:
      `getTimestamp` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### getAsciiStream

    @Pure public @Nullable InputStream getAsciiStream(String columnName) throws SQLException
    Specified by:
      `getAsciiStream` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### getUnicodeStream

    @Pure public @Nullable InputStream getUnicodeStream(String columnName) throws SQLException
    Specified by:
      `getUnicodeStream` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### getBinaryStream

    @Pure public @Nullable InputStream getBinaryStream(String columnName) throws SQLException
    Specified by:
      `getBinaryStream` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### getWarnings

    @Pure public @Nullable SQLWarning getWarnings() throws SQLException
    Specified by:
      `getWarnings` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### clearWarnings

    public void clearWarnings() throws SQLException
    Specified by:
      `clearWarnings` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### addWarning

    protected void addWarning(SQLWarning warnings)

  - ### getCursorName

    public @Nullable String getCursorName() throws SQLException
    Specified by:
      `getCursorName` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### getObject

    public @Nullable Object getObject(@org.checkerframework.checker.index.qual.Positive int columnIndex) throws SQLException
    Specified by:
      `getObject` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### getObject

    public @Nullable Object getObject(String columnName) throws SQLException
    Specified by:
      `getObject` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### findColumn

    public @org.checkerframework.checker.index.qual.NonNegative int findColumn(String columnName) throws SQLException
    Specified by:
      `findColumn` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### createColumnNameIndexMap

    public static Map<String,Integer> createColumnNameIndexMap(Field[] fields, boolean isSanitiserDisabled)

  - ### getColumnOID

    public int getColumnOID(int field)
    Returns the OID of a field. It is used internally by the driver.
    Parameters:
      `field` - field index
    Returns:
      OID of a field

  - ### getFixedString

    public @Nullable String getFixedString(int col) throws SQLException
    This is used to fix get*() methods on Money fields. It should only be used by those methods!

    It converts ($##.##) to -##.## and $##.## to ##.##

    Parameters:
      `col` - column position (1-based)
    Returns:
      numeric-parsable representation of money string literal
    Throws:
      `SQLException` - if something wrong happens

  - ### getPGType

    @Pure protected String getPGType(@org.checkerframework.checker.index.qual.Positive int column) throws SQLException
    Throws:
      `SQLException`

  - ### getSQLType

    @Pure protected int getSQLType(@org.checkerframework.checker.index.qual.Positive int column) throws SQLException
    Throws:
      `SQLException`

  - ### checkClosed

    @Pure @EnsuresNonNull("rows") protected void checkClosed() throws SQLException
    Throws:
      `SQLException`

  - ### isResultSetClosed

    protected boolean isResultSetClosed()

  - ### checkColumnIndex

    @Pure protected void checkColumnIndex(@org.checkerframework.checker.index.qual.Positive int column) throws SQLException
    Throws:
      `SQLException`

  - ### getRawValue

    @EnsuresNonNull("thisRow") protected byte @Nullable [] getRawValue(@org.checkerframework.checker.index.qual.Positive int column) throws SQLException
    Checks that the result set is not closed, it's positioned on a valid row and that the given column number is valid. Also updates the `wasNullFlag` to correct value.
    Parameters:
      `column` - The column number to check. Range starts from 1.
    Returns:
      raw value or null
    Throws:
      `SQLException` - If state or column is invalid.

  - ### isBinary

    @Pure protected boolean isBinary(@org.checkerframework.checker.index.qual.Positive int column)
    Returns true if the value of the given column is in binary format.
    Parameters:
      `column` - The column to check. Range starts from 1.
    Returns:
      True if the column is in binary format.

  - ### toShort

    public static short toShort(@Nullable String s) throws SQLException
    Throws:
      `SQLException`

  - ### toInt

    public static int toInt(@Nullable String s) throws SQLException
    Throws:
      `SQLException`

  - ### toLong

    public static long toLong(@Nullable String s) throws SQLException
    Throws:
      `SQLException`

  - ### toBigDecimal

    public static @PolyNull BigDecimal toBigDecimal(@PolyNull String s) throws SQLException
    Throws:
      `SQLException`

  - ### toBigDecimal

    public static @PolyNull BigDecimal toBigDecimal(@PolyNull String s, int scale) throws SQLException
    Throws:
      `SQLException`

  - ### toFloat

    public static float toFloat(@Nullable String s) throws SQLException
    Throws:
      `SQLException`

  - ### toDouble

    public static double toDouble(@Nullable String s) throws SQLException
    Throws:
      `SQLException`

  - ### updateValue

    protected void updateValue(@org.checkerframework.checker.index.qual.Positive int columnIndex, @Nullable Object value) throws SQLException
    Throws:
      `SQLException`

  - ### getUUID

    @Pure protected Object getUUID(String data) throws SQLException
    Throws:
      `SQLException`

  - ### getUUID

    @Pure protected Object getUUID(byte[] data) throws SQLException
    Throws:
      `SQLException`

  - ### updateRef

    public void updateRef(@org.checkerframework.checker.index.qual.Positive int columnIndex, @Nullable Ref x) throws SQLException
    Specified by:
      `updateRef` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateRef

    public void updateRef(String columnName, @Nullable Ref x) throws SQLException
    Specified by:
      `updateRef` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateBlob

    public void updateBlob(@org.checkerframework.checker.index.qual.Positive int columnIndex, @Nullable Blob x) throws SQLException
    Specified by:
      `updateBlob` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateBlob

    public void updateBlob(String columnName, @Nullable Blob x) throws SQLException
    Specified by:
      `updateBlob` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateClob

    public void updateClob(@org.checkerframework.checker.index.qual.Positive int columnIndex, @Nullable Clob x) throws SQLException
    Specified by:
      `updateClob` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateClob

    public void updateClob(String columnName, @Nullable Clob x) throws SQLException
    Specified by:
      `updateClob` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateArray

    public void updateArray(@org.checkerframework.checker.index.qual.Positive int columnIndex, @Nullable Array x) throws SQLException
    Specified by:
      `updateArray` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateArray

    public void updateArray(String columnName, @Nullable Array x) throws SQLException
    Specified by:
      `updateArray` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### getObject

    public <T> @Nullable T getObject(@org.checkerframework.checker.index.qual.Positive int columnIndex, Class<T> type) throws SQLException
    Specified by:
      `getObject` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### getObject

    public <T> @Nullable T getObject(String columnLabel, Class<T> type) throws SQLException
    Specified by:
      `getObject` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### getObject

    public @Nullable Object getObject(String s, @Nullable Map<String,Class<?>> map) throws SQLException
    Specified by:
      `getObject` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### getObject

    public @Nullable Object getObject(@org.checkerframework.checker.index.qual.Positive int i, @Nullable Map<String,Class<?>> map) throws SQLException
    Specified by:
      `getObject` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateObject

    public void updateObject(@org.checkerframework.checker.index.qual.Positive int columnIndex, @Nullable Object x, SQLType targetSqlType, int scaleOrLength) throws SQLException
    Specified by:
      `updateObject` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateObject

    public void updateObject(String columnLabel, @Nullable Object x, SQLType targetSqlType, int scaleOrLength) throws SQLException
    Specified by:
      `updateObject` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateObject

    public void updateObject(@org.checkerframework.checker.index.qual.Positive int columnIndex, @Nullable Object x, SQLType targetSqlType) throws SQLException
    Specified by:
      `updateObject` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateObject

    public void updateObject(String columnLabel, @Nullable Object x, SQLType targetSqlType) throws SQLException
    Specified by:
      `updateObject` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### getRowId

    public @Nullable RowId getRowId(@org.checkerframework.checker.index.qual.Positive int columnIndex) throws SQLException
    Specified by:
      `getRowId` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### getRowId

    public @Nullable RowId getRowId(String columnName) throws SQLException
    Specified by:
      `getRowId` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateRowId

    public void updateRowId(@org.checkerframework.checker.index.qual.Positive int columnIndex, @Nullable RowId x) throws SQLException
    Specified by:
      `updateRowId` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateRowId

    public void updateRowId(String columnName, @Nullable RowId x) throws SQLException
    Specified by:
      `updateRowId` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### getHoldability

    public int getHoldability() throws SQLException
    Specified by:
      `getHoldability` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### isClosed

    public boolean isClosed() throws SQLException
    Specified by:
      `isClosed` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateNString

    public void updateNString(@org.checkerframework.checker.index.qual.Positive int columnIndex, @Nullable String nString) throws SQLException
    Specified by:
      `updateNString` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateNString

    public void updateNString(String columnName, @Nullable String nString) throws SQLException
    Specified by:
      `updateNString` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateNClob

    public void updateNClob(@org.checkerframework.checker.index.qual.Positive int columnIndex, @Nullable NClob nClob) throws SQLException
    Specified by:
      `updateNClob` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateNClob

    public void updateNClob(String columnName, @Nullable NClob nClob) throws SQLException
    Specified by:
      `updateNClob` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateNClob

    public void updateNClob(@org.checkerframework.checker.index.qual.Positive int columnIndex, @Nullable Reader reader) throws SQLException
    Specified by:
      `updateNClob` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateNClob

    public void updateNClob(String columnName, @Nullable Reader reader) throws SQLException
    Specified by:
      `updateNClob` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateNClob

    public void updateNClob(@org.checkerframework.checker.index.qual.Positive int columnIndex, @Nullable Reader reader, long length) throws SQLException
    Specified by:
      `updateNClob` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateNClob

    public void updateNClob(String columnName, @Nullable Reader reader, long length) throws SQLException
    Specified by:
      `updateNClob` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### getNClob

    public @Nullable NClob getNClob(@org.checkerframework.checker.index.qual.Positive int columnIndex) throws SQLException
    Specified by:
      `getNClob` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### getNClob

    public @Nullable NClob getNClob(String columnName) throws SQLException
    Specified by:
      `getNClob` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateBlob

    public void updateBlob(@org.checkerframework.checker.index.qual.Positive int columnIndex, @Nullable InputStream inputStream, long length) throws SQLException
    Specified by:
      `updateBlob` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateBlob

    public void updateBlob(String columnName, @Nullable InputStream inputStream, long length) throws SQLException
    Specified by:
      `updateBlob` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateBlob

    public void updateBlob(@org.checkerframework.checker.index.qual.Positive int columnIndex, @Nullable InputStream inputStream) throws SQLException
    Specified by:
      `updateBlob` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateBlob

    public void updateBlob(String columnName, @Nullable InputStream inputStream) throws SQLException
    Specified by:
      `updateBlob` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateClob

    public void updateClob(@org.checkerframework.checker.index.qual.Positive int columnIndex, @Nullable Reader reader, long length) throws SQLException
    Specified by:
      `updateClob` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateClob

    public void updateClob(String columnName, @Nullable Reader reader, long length) throws SQLException
    Specified by:
      `updateClob` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateClob

    public void updateClob(@org.checkerframework.checker.index.qual.Positive int columnIndex, @Nullable Reader reader) throws SQLException
    Specified by:
      `updateClob` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateClob

    public void updateClob(String columnName, @Nullable Reader reader) throws SQLException
    Specified by:
      `updateClob` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### getSQLXML

    @Pure public @Nullable SQLXML getSQLXML(@org.checkerframework.checker.index.qual.Positive int columnIndex) throws SQLException
    Specified by:
      `getSQLXML` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### getSQLXML

    public @Nullable SQLXML getSQLXML(String columnName) throws SQLException
    Specified by:
      `getSQLXML` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateSQLXML

    public void updateSQLXML(@org.checkerframework.checker.index.qual.Positive int columnIndex, @Nullable SQLXML xmlObject) throws SQLException
    Specified by:
      `updateSQLXML` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateSQLXML

    public void updateSQLXML(String columnName, @Nullable SQLXML xmlObject) throws SQLException
    Specified by:
      `updateSQLXML` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### getNString

    public @Nullable String getNString(@org.checkerframework.checker.index.qual.Positive int columnIndex) throws SQLException
    Specified by:
      `getNString` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### getNString

    public @Nullable String getNString(String columnName) throws SQLException
    Specified by:
      `getNString` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### getNCharacterStream

    public @Nullable Reader getNCharacterStream(@org.checkerframework.checker.index.qual.Positive int columnIndex) throws SQLException
    Specified by:
      `getNCharacterStream` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### getNCharacterStream

    public @Nullable Reader getNCharacterStream(String columnName) throws SQLException
    Specified by:
      `getNCharacterStream` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateNCharacterStream

    public void updateNCharacterStream(@org.checkerframework.checker.index.qual.Positive int columnIndex, @Nullable Reader x, int length) throws SQLException
    Throws:
      `SQLException`

  - ### updateNCharacterStream

    public void updateNCharacterStream(String columnName, @Nullable Reader x, int length) throws SQLException
    Throws:
      `SQLException`

  - ### updateNCharacterStream

    public void updateNCharacterStream(@org.checkerframework.checker.index.qual.Positive int columnIndex, @Nullable Reader x) throws SQLException
    Specified by:
      `updateNCharacterStream` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateNCharacterStream

    public void updateNCharacterStream(String columnName, @Nullable Reader x) throws SQLException
    Specified by:
      `updateNCharacterStream` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateNCharacterStream

    public void updateNCharacterStream(@org.checkerframework.checker.index.qual.Positive int columnIndex, @Nullable Reader x, long length) throws SQLException
    Specified by:
      `updateNCharacterStream` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateNCharacterStream

    public void updateNCharacterStream(String columnName, @Nullable Reader x, long length) throws SQLException
    Specified by:
      `updateNCharacterStream` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateCharacterStream

    public void updateCharacterStream(@org.checkerframework.checker.index.qual.Positive int columnIndex, @Nullable Reader reader, long length) throws SQLException
    Specified by:
      `updateCharacterStream` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateCharacterStream

    public void updateCharacterStream(String columnName, @Nullable Reader reader, long length) throws SQLException
    Specified by:
      `updateCharacterStream` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateCharacterStream

    public void updateCharacterStream(@org.checkerframework.checker.index.qual.Positive int columnIndex, @Nullable Reader reader) throws SQLException
    Specified by:
      `updateCharacterStream` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateCharacterStream

    public void updateCharacterStream(String columnName, @Nullable Reader reader) throws SQLException
    Specified by:
      `updateCharacterStream` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateBinaryStream

    public void updateBinaryStream(@org.checkerframework.checker.index.qual.Positive int columnIndex, @Nullable InputStream inputStream, long length) throws SQLException
    Specified by:
      `updateBinaryStream` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateBinaryStream

    public void updateBinaryStream(String columnName, @Nullable InputStream inputStream, long length) throws SQLException
    Specified by:
      `updateBinaryStream` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateBinaryStream

    public void updateBinaryStream(@org.checkerframework.checker.index.qual.Positive int columnIndex, @Nullable InputStream inputStream) throws SQLException
    Specified by:
      `updateBinaryStream` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateBinaryStream

    public void updateBinaryStream(String columnName, @Nullable InputStream inputStream) throws SQLException
    Specified by:
      `updateBinaryStream` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateAsciiStream

    public void updateAsciiStream(@org.checkerframework.checker.index.qual.Positive int columnIndex, @Nullable InputStream inputStream, long length) throws SQLException
    Specified by:
      `updateAsciiStream` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateAsciiStream

    public void updateAsciiStream(String columnName, @Nullable InputStream inputStream, long length) throws SQLException
    Specified by:
      `updateAsciiStream` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateAsciiStream

    public void updateAsciiStream(@org.checkerframework.checker.index.qual.Positive int columnIndex, @Nullable InputStream inputStream) throws SQLException
    Specified by:
      `updateAsciiStream` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### updateAsciiStream

    public void updateAsciiStream(String columnName, @Nullable InputStream inputStream) throws SQLException
    Specified by:
      `updateAsciiStream` in interface `ResultSet`
    Throws:
      `SQLException`

  - ### isWrapperFor

    public boolean isWrapperFor(Class<?> iface) throws SQLException
    Specified by:
      `isWrapperFor` in interface `Wrapper`
    Throws:
      `SQLException`

  - ### unwrap

    public <T> T unwrap(Class<T> iface) throws SQLException
    Specified by:
      `unwrap` in interface `Wrapper`
    Throws:
      `SQLException`

  - ### upperCaseFieldLabels

    protected PgResultSet upperCaseFieldLabels()
    This is here to be used by metadata functions to make all column labels upper case. Because postgres folds columns to lower case in queries it will be easier to change the fields after the fact rather than try to coerce all the columns to upper case in the queries as this would require surrounding all columns with " and escaping them making them even harder to read than they are now.
    Returns:
      PgResultSet